.586
.model flat,stdcall
option casemap:none

include WritePrinter.inc

.code

start:
	invoke	LoadLibrary, offset szWinSpoolDRV
	or		eax, eax
	jnz		@F
	invoke	LoadLibrary, offset szWinSpoolDLL
@@:
	mov		hSpoolLib, eax
	invoke	GetProcAddress, hSpoolLib, offset szOpenPrinterA
	mov		pOpenPrinterA, eax
		PrintDec eax
	invoke	GetProcAddress, hSpoolLib, offset szStartDocPrinterA
	mov		pStartDocPrinterA, eax
		PrintDec eax
	invoke	GetProcAddress, hSpoolLib, offset szStartPagePrinter
	mov		pStartPagePrinter, eax
		PrintDec eax
	invoke	GetProcAddress, hSpoolLib, offset szWritePrinter
	mov		pWritePrinter, eax
		PrintDec eax
	invoke	GetProcAddress, hSpoolLib, offset szEndPagePrinter
	mov		pEndPagePrinter, eax
		PrintDec eax
	invoke	GetProcAddress, hSpoolLib, offset szEndDocPrinter
	mov		pEndDocPrinter, eax
		PrintDec eax
	invoke	GetProcAddress, hSpoolLib, offset szClosePrinter
	mov		pClosePrinter, eax
		PrintDec eax
;Open the printer
	push	NULL
	push	offset hPrinter
	push	offset szPrintrName
	call	pOpenPrinterA						;Open printer
		PrintDec eax
	.if( eax == 0 )
		jmp	GetOut
	.endif
;Notify the spooler of a new Document
	mov		doci.pDocName, offset szMyDoc
	mov		doci.pOutputFile, NULL
	mov		doci.pDatatype, offset szRaw
	push	offset doci
	push	1
	push	hPrinter
	call	pStartDocPrinterA					;Start printer
	mov		pJob, eax
		PrintDec eax
	.if( eax == 0 )
		jmp	ClsPrn
	.endif
;Begin new page
	push	hPrinter
	call	pStartPagePrinter
		PrintDec eax
	.if( eax == 0 )
		jmp	EndDoc
	.endif
;Print first line
	push	offset nobp							;number of bytes printed
	push	sizeof szLine1
	push	offset szLine1
	push	hPrinter
	call	pWritePrinter
		PrintDec eax
;Send Carriage Return & Line Feed
	push	offset nobp							;number of bytes printed
	push	sizeof CrLf
	push	offset CrLf
	push	hPrinter
	call	pWritePrinter
		PrintDec eax
;Print second line
	push	offset nobp							;number of bytes printed
	push	sizeof szLine2
	push	offset szLine2
	push	hPrinter
	call	pWritePrinter
		PrintDec eax
;Send Carriage Return & Line Feed
	push	offset nobp							;number of bytes printed
	push	sizeof CrLf
	push	offset CrLf
	push	hPrinter
	call	pWritePrinter
		PrintDec eax
;End page
	push	hPrinter
	call	pEndPagePrinter
		PrintDec eax
;End Document
EndDoc:
	push	hPrinter
	call	pEndDocPrinter
		PrintDec eax
;Close Priner
ClsPrn:
	push	hPrinter
	call	pClosePrinter
		PrintDec eax
GetOut:
	invoke	ExitProcess,eax

end start
